Attribute VB_Name = "CoriFlow"
Public Const CORI_Rvalue = 20
Public Const CORI_Rsetpoint = 21
Public Const CORI_Rkp = 22
Public Const CORI_Rti = 23
Public Const CORI_Rtd = 24
Public Const CORI_Fluidtemp = 25
Public Const CORI_Rho = 26
Public Const CORI_Capacity = 27
Public Const CORI_Pressure = 28
Public Const CORI_WR_Protect = 29
Public Cori(CORI_Rvalue To 30) As Long

Public Const CORI_CHAR = &H0
Public Const CORI_INT = &H20
Public Const CORI_FLOAT = &H40
Public Const CORI_STRING = &H60
Public Const CORI_tWRITE = 2
Public Const CORI_tREAD = 4
Public Const CORI_NODE = 80

Public Const CR_FB = 3
Public Const CR_PR = 1
Public Const CR_Type = 2
Public Const ownPR = 0

Type tCmd
Fbnr As Byte
Process As Byte
ownProcess As Byte
dType As Byte
End Type

Public CR_KP()
Public CR_TD()
Public CR_TI()
Public CR_Messure()
Public CR_Setpoint(), CR_Fluidtemp(), CR_Rho(), CR_Capacity(), CR_Pressure()
Public CR_Protect()

Public MassenstromCoriMax As Integer


Sub SetConst()
CR_KP = Array(CORI_Rkp, 114, CORI_FLOAT, 21)
CR_TI = Array(CORI_Rti, 114, CORI_FLOAT, 22)
CR_TD = Array(CORI_Rtd, 114, CORI_FLOAT, 23)
CR_Messure = Array(CORI_Rvalue, 1, CORI_INT, 0)
CR_Setpoint = Array(CORI_Rsetpoint, 1, CORI_INT, 1)
CR_Fluidtemp = Array(CORI_Fluidtemp, 33, CORI_FLOAT, 7)
CR_Pressure = Array(CORI_Pressure, 33, CORI_FLOAT, 8)
CR_Rho = Array(CORI_Rho, 33, CORI_FLOAT, 21)
CR_Capacity = Array(CORI_Capacity, 1, CORI_FLOAT, 13)
CR_Protect = Array(CORI_WR_Protect, 0, CORI_CHAR, 10)
End Sub



'Dim cmds() 'wird als Konstante verwendet - daher keine Zuweisungen im Programm
'cmds(KP) = Array(KP)(114, CORI_FLOAT, 21)


Function CreateCoriStr2(RW As Byte, ownProcess As Byte, Process As Byte, datatype As Byte, Fbnummer As Byte)
Dim dmNull As String
If Process < 10 Then dmNull = "0" Else: dmNull = ""

CreateCoriStr = ":06" & CStr(CORI_NODE) & "0" & CStr(RW) & "01" & CStr(ownProcess) & dmNull & Hex$(Process) & Hex$(datatype Or Fbnummer)
End Function

Function CreateCoriStrWrite(cmds(), ByVal values As Double)
Dim dmNull As String, CmdString As String, CmdLen As Integer, SetCR As String, DT_LEN As Byte, CmdStr As String
If cmds(CR_PR) < 10 Then dmNull = "0" Else: dmNull = ""
Select Case cmds(CR_Type)
    Case CORI_FLOAT: SetCR = FloatToHex(values): DT_LEN = 8
    Case CORI_INT: SetCR = Hex(values): DT_LEN = 4
    Case CORI_CHAR: SetCR = Hex(values): DT_LEN = 2
End Select
CmdLen = Len(SetCR)
If CmdLen <> DT_LEN Then
    For i = 1 To DT_LEN - CmdLen
        SetCR = "0" & SetCR
    Next
End If

CmdStr = CStr(Hex$(cmds(CR_Type) Or cmds(CR_FB)))
If Len(CmdStr) Mod 2 Then CmdStr = "0" & CmdStr
Proc = CStr(Hex$(cmds(CR_PR))) 'Prft auf einstellige Processnummern
If Len(Proc) Mod 2 Then Proc = "0" & Proc

CmdString = CStr(CORI_NODE) & "0" & CStr(CORI_tWRITE) & Proc & CmdStr & SetCR
CmdLen = Len(CmdString)
If CmdLen Mod 2 Then Exit Function
CreateCoriStrWrite = ":0" & CmdLen / 2 & CmdString & vbCrLf
End Function

Function CreateCoriStrRead(cmds())
Dim dmNull As String, CmdString As String, CmdLen As Integer, CmdStr As String
If cmds(CR_PR) < 10 Then dmNull = "0" Else: dmNull = ""
CmdStr = CStr(Hex$(cmds(CR_Type) Or cmds(CR_FB)))
If Len(CmdStr) Mod 2 Then CmdStr = "0" & CmdStr
CmdString = CStr(CORI_NODE) & "0" & CStr(CORI_tREAD) & "01" & CStr(cmds(own_PR)) & dmNull & Hex$(cmds(CR_PR)) & CmdStr
CmdLen = Len(CmdString)
If CmdLen Mod 2 Then Exit Function
CreateCoriStrRead = ":0" & CmdLen / 2 & CmdString & vbCrLf
End Function


'UMRECHUNG VON HEX-BYTES IN DEZIMALZAHLEN
'---------------------------------------------------------------------------------------
Function HexInDez(HexZahl)
'CAVE: Doppelpunkt mitzhlen
HexZahl = RTrim(HexZahl)
StartBitHex = 12
LaengeHex = 4
HexStr = Mid(HexZahl, StartBitHex, LaengeHex)
'Quelle: http://www.vbarchiv.net/tipps/details.php?id=276
'Quelle: http://www.1sayfa.com/1024/diger/vb/ch12.htm#Heading16
If HexStr <> "" Then
    HexInDez = CDbl("&H" & HexStr)
    End If
End Function

Function FlowMasseCORI(FlowAbs) ' Ausgabe Massenstrom in g/min

'Umrechnung der bipolaren dezimalen Absolutwerte in den Massenstrom (MiniCori); Referenz: 9.17.023, page 12
If FlowAbs < 41942 Then
    'Messwert im Positiven Bereich
    FlowMasseCORI = Round(FlowAbs / 32000 * (MassenstromCoriMax / 60), 3) 'Dezimalwert / Messbereich * (100%-Flow pro h / 60 Minuten)
Else
    'Messwert im negativen Bereich
    FlowMasseCORI = Round(-(65535 - FlowAbs) / (65535 - 41943) * 0.7373 * (MassenstromCoriMax / 60), 3)
End If
End Function

Function FlowProzent(FlowAbs)
'Umrechnung der bipolaren dezimalen Absolutwerte in Prozentwerte; Referenz: 9.17.023, page 12
If FlowAbs < 41942 Then 'lokal dimensioniert
    'Messwert im Positiven Bereich
    FlowProzent = Round(Val(FlowAbs) * 131.07 / 41942, 3)
Else
    'Messwert im negativen Bereich
    FlowProzent = Round(-(65535 - Val(FlowAbs)) / (65535 - 41943) * 73.73, 3)
End If
End Function

Function FlowAbsolut(FlowAbs)
'Zuweisung des Vorzeichens der bipolaren dezimalen Absolutwerte; Referenz: 9.17.023, page 12
If FlowAbs < 41942 Then
    'Messwert im Positiven Bereich
    FlowAbsolut = FlowAbs
Else
    'Messwert im negativen Bereich
    FlowAbsolut = FlowAbs - 65535
End If
End Function

Function SetCori(txtMiniCoriSollInput)


End Function

Function LongToFloat(ByVal Param As Long) As Double
Dim expH As Byte
Dim bit(31) As Long
Dim exponente As Integer, mantisse As Double
For i = 0 To 30
    bit(i) = (Param And 2 ^ i) / 2 ^ i
Next
For i = 23 To 30
    expH = expH + bit(i) * 2 ^ (i - 23)
Next
exponente = expH - 127

For i = 1 To 23
    If bit(23 - i) = 1 Then mantisse = mantisse + 1 / 2 ^ i
Next
LongToFloat = 2 ^ exponente * (1 + mantisse)
End Function

Static Function Log2(X)
   Log2 = Log(X) / Log(2#)
End Function

Function FloatToHex(X) As String
    Dim e As Integer
    Dim float, m As Long
    
    If X <> 0 Then
        e = Math.Round(Log2(Abs(X)) - 0.5)
        m = (Abs(X) / (2 ^ e) - 1) * 2 ^ 23
        e = e + 127
        float = m
        float = float Or (e * &H800000)
        If X < 0 Then
            float = float Or &H80000000
        End If
    Else
        float = 0
    End If
    
    FloatToHex = Hex$(float)
End Function
