Attribute VB_Name = "Graph"
 Public Const SRCCOPY = &HCC0020 ' (DWORD) dest = source
 

      Public Declare Function CreateCompatibleDC Lib "gdi32" _
                     (ByVal hdc As Long) As Long

      Public Declare Function CreateCompatibleBitmap Lib "gdi32" _
                     (ByVal hdc As Long, _
                     ByVal nWidth As Long, _
                     ByVal nHeight As Long) As Long

      Public Declare Function SelectObject Lib "gdi32" _
                     (ByVal hdc As Long, _
                     ByVal hObject As Long) As Long

      Public Declare Function CreatePen Lib "gdi32" _
                     (ByVal nPenStyle As Long, _
                     ByVal nWidth As Long, _
                     ByVal crColor As Long) As Long

      Public Declare Function LineTo Lib "gdi32" _
                     (ByVal hdc As Long, _
                     ByVal X As Long, _
                     ByVal y As Long) As Long

      Public Declare Function MoveToEx Lib "gdi32" _
                     (ByVal hdc As Long, _
                     ByVal X As Long, _
                     ByVal y As Long, _
                     ByVal lpPoint As Long) As Long

      Public Declare Function BitBlt Lib "gdi32" _
                     (ByVal hDestDC As Long, _
                     ByVal X As Long, _
                     ByVal y As Long, _
                     ByVal nWidth As Long, _
                     ByVal nHeight As Long, _
                     ByVal hSrcDC As Long, _
                     ByVal xSrc As Long, _
                     ByVal ySrc As Long, _
                     ByVal dwRop As Long) As Long
                     
      Public Declare Function TextOut Lib "gdi32" Alias "TextOutA" _
                    (ByVal hdc As Long, _
                    ByVal X As Long, _
                    ByVal y As Long, _
                    ByVal lpString As String, _
                    ByVal nCount As Long) As Long

Public CounterX1 As Long  ' Number of data points logged so far. Used tosync grid.
Public CounterX2 As Long
                     
Public Const pWidth = 500    ' Width of picture box in pixels.
Public Const pHeight = 280   ' Height of picture box in pixels.
Public Const pGrid = 50      ' Distance between grid lines.
Public Const tInterval = 100 ' Interval between timer samplings
                                  ' in milliseconds.
Public Const pHeightHalf = pHeight \ 2

Public Const PS_SOLID = 0
Public Const PS_DASH = 1 ' The pen is dashed. This style is valid only when the pen width is one or less in device units.
Public Const PS_DOT = 2 'The pen is dotted. This style is valid only when the pen width is one or less in device units.
Public Const PS_DASHDOT = 3 ' The pen has alternating dashes and dots. This style is valid only when the pen width is one or less in device units.
Public Const PS_DASHDOTDOT = 4 'The pen has alternating dashes and double dots. This style is valid only when the pen width is one or less in device units.
Public Const PS_NULL = 5 'The pen is invisible.
Public Const PS_INSIDEFRAME = 6
Private hBmp1 As Long
Private hDCh1 As Long
Public hBmp2 As Long
Public hDCh2 As Long

Public OldY(14) As Long     ' Contains the previous y coordinate.
Public hPenBlack As Long, hPenRed As Long, hPenGridLines As Long, hPenBlue As Long, hPenGreen As Long
Public hPenDarkred As Long, hPenDarkblue As Long, hPenYellow As Long, hPenCyan As Long, hPenMagenta As Long, hPenDarkgreen As Long, hPenDarkyellow As Long


Public Sub SetCurves()
hPenBlack = CreatePen(PS_SOLID, 1, vbBlack)
hPenGridLines = CreatePen(PS_DOT, 1, RGB(128, 128, 128))
hPenRed = CreatePen(PS_SOLID, 2, vbRed)
hPenBlue = CreatePen(PS_SOLID, 2, vbBlue)
hPenGreen = CreatePen(PS_SOLID, 2, vbGreen)
hPenCyan = CreatePen(PS_SOLID, 2, vbCyan)
hPenMagenta = CreatePen(PS_SOLID, 2, vbMagenta)
hPenYellow = CreatePen(PS_SOLID, 2, vbYellow)
hPenDarkred = CreatePen(PS_SOLID, 2, RGB(128, 0, 0))
hPenDarkblue = CreatePen(PS_SOLID, 2, RGB(0, 0, 128))
hPenDarkyellow = CreatePen(PS_SOLID, 2, RGB(128, 128, 0))
hPenDarkgreen = CreatePen(PS_SOLID, 2, RGB(0, 128, 128))
End Sub



Public Sub Refreshs1(ByVal counter As Integer)
Call BitBlt(hDCh1, 0, 0, pWidth - 1, pHeight, hDCh1, 1, 0, SRCCOPY)
If counter Mod pGrid = 0 Then
    Call MoveToEx(hDCh1, pWidth - 2, 0, 0)
    Call LineTo(hDCh1, pWidth - 2, pHeight)
End If
If counter Mod pGrid * 3 = 0 Then Call TextOut(hDCh1, pWidth - 60, pHeight - 15, Format(Now, "hh:nn:ss"), 8)
End Sub


Public Sub Init1()
Dim i As Integer
With Graph1
    .Show
    counter = 0
    .Pic.ScaleMode = 3
    .ScaleMode = 3
    .Pic.Height = 285
    .Pic.Width = 505
    hDCh1 = CreateCompatibleDC(.Pic.hdc)
    hBmp1 = CreateCompatibleBitmap(.Pic.hdc, pWidth, pHeight)
       
    Call SelectObject(hDCh1, hBmp1)
    Call SelectObject(hDCh1, hPenGridLines)

    'Plot horizontal grid lines.
    For i = pGrid To pHeight - 1 Step pGrid
            .Pic.Line (0, i)-(pWidth, i)
    Next

    ' Plot vertical grid lines.
    For i = pGrid - (counter Mod pGrid) To pWidth - 1 Step pGrid
        .Pic.Line (i, 0)-(i, pHeight)
    Next

    Test = BitBlt(hDCh1, 0, 0, pWidth, pHeight, _
                     .Pic.hdc, _
                     0, 0, SRCCOPY)
    .Timer_Picture.Interval = 100
    .Timer_Picture.Enabled = True
    .HScroll.Value = .Timer_Picture.Interval
End With
End Sub

Public Sub DrawPoint1(ByVal NewY As Integer, Index As Byte, ByVal hPen As Long)
Call SelectObject(hDCh1, hPen)
Call MoveToEx(hDCh1, pWidth - 3, OldY(Index), 0)
Call LineTo(hDCh1, pWidth - 2, NewY)
Call SelectObject(hDCh1, hPenGridLines)
Call BitBlt(Graph1.Pic.hdc, 0, 0, pWidth, pHeight, hDCh1, 0, 0, SRCCOPY)
OldY(Index) = NewY
End Sub

Public Sub Refreshs2(ByVal counter As Integer)
Call BitBlt(hDCh2, 0, 0, pWidth - 1, pHeight, hDCh2, 1, 0, SRCCOPY)
If counter Mod pGrid = 0 Then
    Call MoveToEx(hDCh2, pWidth - 2, 0, 0)
    Call LineTo(hDCh2, pWidth - 2, pHeight)
    'Else: Call MoveToEx(hDCh1, 0, pGrid, 0): Call LineTo(hDCh1, pWidth, pGrid)
End If
If counter Mod pGrid * 3 = 0 Then Call TextOut(hDCh2, pWidth - 60, pHeight - 15, Format(Now, "hh:nn:ss"), 8)
End Sub


Public Sub Init2()
Dim i As Integer
With Graph2
    .Show
    counter = 0
    .Pic.ScaleMode = 3
    .ScaleMode = 3
    .Pic.Height = 285
    .Pic.Width = 505
    
    hDC_Temp = MemoryDC_Create
    'hBmp2 = CreateCompatibleBitmap(hDC_Temp, pWidth, pHeight)
    
    hDCh2 = CreateCompatibleDC(.Pic.hdc)
    hBmp2 = CreateCompatibleBitmap(.Pic.hdc, pWidth, pHeight)
       
    Call SelectObject(hDCh2, hBmp2)
    Call SelectObject(hDCh2, hPenGridLines)

    ' Plot horizontal grid lines.
    For i = pGrid To pHeight - 1 Step pGrid
        .Pic.Line (0, i)-(pWidth, i)
    Next

    ' Plot vertical grid lines.
    For i = pGrid - (counter Mod pGrid) To pWidth - 1 Step pGrid
        .Pic.Line (i, 0)-(i, pHeight)
    Next

    Call BitBlt(hDCh2, 0, 0, pWidth, pHeight, _
                     .Pic.hdc, _
                     0, 0, SRCCOPY)
    .Timer_Picture.Interval = 100
    .Timer_Picture.Enabled = True
    .HScroll.Value = .Timer_Picture.Interval
End With
End Sub

Public Sub DrawPoint2(ByVal NewY As Integer, Index As Byte, ByVal hPen As Long)
Call SelectObject(hDCh2, hPen)
Call MoveToEx(hDCh2, pWidth - 3, OldY(Index), 0)
Call LineTo(hDCh2, pWidth - 2, NewY)
Call SelectObject(hDCh2, hPenGridLines)
Call BitBlt(Graph2.Pic.hdc, 0, 0, pWidth, pHeight, hDCh2, 0, 0, SRCCOPY)
OldY(Index) = NewY
End Sub

