Attribute VB_Name = "mVisio"
Public vsoPage As Visio.Page
Public vsoShape As Visio.Shape
Public Const mstrShapesFoundPrompt As String = "Shapes at the click location:"
Public Const mstrNoShapesFoundPrompt As String = "No shapes at the click location."
Public vsoEventList As Visio.EventList
'Implements Visio.IVisEventProc
Public vsoEvent As Visio.Event
Public Const vsoInstDesc As Byte = 2
Public Const vsoVesselDesc As Byte = 1
Public Const TIRmax As Byte = 6
Public vsoEdukt As Visio.Shape, vsoProdukt As Visio.Shape, vsoReaktor As Visio.Shape, vsoCori As Visio.Shape
Public vsoPumpe As Visio.Shape, vsoFilter As Visio.Shape, vsoTIR(1 To TIRmax) As Visio.Shape, vsoAdditiv As Visio.Shape, vsoFIRC As Visio.Shape
Public vsoWIR As Visio.Shape, vsoPI(1 To 3) As Visio.Shape
Public VDC As DrawingControl

Function InitVisio()
With VDC.Window
.ShowRulers = False
.ShowGrid = False
.ShowGuides = False
.ShowConnectPoints = False
.ShowPageBreaks = False
.ShowPageOutline = False
.ShowPageTabs = False
.BackgroundColor = vbWhite
.ShowScrollBars = visScrollBarNeither
'.BackgroundColorGradient = vbBlue
End With
End Function

Function InitShapes()
Set vsoEdukt = getShape("Edukt")
Set vsoProdukt = getShape("Produkt")
Set vsoReaktor = getShape("Reaktor")
Set vsoCori = getShape("CORI")
Set vsoPumpe = getShape("Pumpe")
Set vsoFilter = getShape("Filter")
Set vsoAdditiv = getShape("Additiv")
Set vsoWIR = getShape("WIR")
Set vsoFIRC = getShape("FIRC")
For i = 1 To TIRmax
    Set vsoTIR(i) = getShape("TIR" & i)
Next
For i = 1 To 3
    Set vsoPI(i) = getShape("PI" & i)
Next
End Function

Public Sub ChangeBackgr(oShape As Visio.Shape, Rot As Byte, Gelb As Byte, Blau As Byte)
If Not (oShape Is Nothing) Then oShape.CellsSRC(visSectionObject, visRowFill, visFillForegnd).FormulaU = "THEMEGUARD(RGB(" & Rot & "," & Gelb & "," & Blau & "))"
End Sub

Public Sub ChangeDescription(oShape As Visio.Shape, vType As Byte, ByVal Value As Double)
If Not (oShape Is Nothing) Then oShape.CellsSRC(visSectionProp, vType, visCustPropsValue).FormulaU = """" & Value & """"
End Sub

Function getShape(Name As String) As Visio.Shape
Dim oShape As Visio.Shape
Set vsoPage = C4Alkylierung.DrawingControl1.Window.Page
For Each oShape In vsoPage.Shapes
   If oShape.Text = Name Then Set getShape = oShape: Exit Function
Next oShape
End Function


Public Sub Initialize(ByRef vsoSubjectWindow As Visio.Window)
'
' Inialize
'
' Abstract - This stores the reference to the window so
' that processing of the MouseUp event can occur.
'
' Parameters
' vsoSubjectWindow      the active window of a running visio instance
'
    Set mvsoWindow = vsoSubjectWindow
    
End Sub

Public Function getMouseClickShapes(ByVal vsoClickedPage As Visio.Page, _
    ByVal dblClickedLocationX As Double, _
    ByVal dblClickedLocationY As Double, _
    ByVal dblTolerance As Double) _
    As Visio.Selection
'
' getMouseClickShapes
'
' Abstract - This function finds the shapes that are at the specified
' location.  This is usually used in response to a mouse click event.
'
' Parameters
' vsoClickedPage        Page containing the shapes
' dblClickedLocationX   Horizontal coordinate in Visio units
' dblClickedLocationX   Vertical coordinate in Visio units
' dblTolerance          Tolerance value to use
'
' Return Value          Selection object containing the list of shapes
'                       that are at the specified location
'                       {The Selection is Nothing if an error occured.)
'
    Dim vsoClickedShapes As Visio.Selection

    On Error GoTo GetMouseClickShapes_Err
    
    ' Use the SpatialSearch function of the page to get the list
    ' of shapes at the location.
    Set vsoClickedShapes = vsoClickedPage.SpatialSearch( _
        dblClickedLocationX, dblClickedLocationY, _
        Visio.VisSpatialRelationCodes.visSpatialContainedIn, _
        dblTolerance, Visio.VisSpatialRelationFlags.visSpatialFrontToBack)

    Set getMouseClickShapes = vsoClickedShapes
    
    Exit Function
    
GetMouseClickShapes_Err:
    Debug.Print Err.Description

End Function


Public Sub mvsoWindow_MouseUp(ByVal lngButton As Long, _
    ByVal lngKeyButtonState As Long, _
    ByVal dblX As Double, _
    ByVal dblY As Double, _
    ByRef blnCancelDefault As Boolean)
'
' mvsoWindow_MouseUp
'
' Abstract - Event handling procedure for the MouseUp event of
' the window.  If the left mouse button was clicked, all shapes
' at the click location are listed.
'
' Parameters
' lngButton         Indicates which mouse button was clicked
' lngKeyButtonState State of the shift and control button
'                   (This parameter is ignored in this procedure.)
' dblX              Horizontal coordinate on the page of the mouse
'                   cursor at the time the mouse button was clicked
' dblY              Vertical coordinate on the page of the mouse
'                   cursor at the time the mouse button was clicked
' blnCancelDefault  Flag to set to cancel processing of the mouse click
'                   (This parameter is ignored in this procedure.)
'
    Const TOLERANCE As Double = 0.0001
    
    Dim vsoClickedShapes As Visio.Selection
    Dim lngNextShape As Long
    Dim strMessage As String
    
    On Error GoTo mvsoWindow_MouseUp_Err
    
    ' Check if the left mouse Button caused this event to occur.
    If lngButton = Visio.VisKeyButtonFlags.visMouseLeft Then

        ' Get the list of shapes at the click location.
        Set vsoClickedShapes = getMouseClickShapes( _
            mvsoWindow.PageAsObj, dblX, dblY, TOLERANCE)

        ' Check if any shapes were found.
        If (Not vsoClickedShapes Is Nothing) Then
            If (vsoClickedShapes.Count > 0) Then

                ' Write the name of each clicked shape to the
                ' debug window.
                strMessage = mstrShapesFoundPrompt & vbCrLf
    
                ' Loop through the collection of clicked shapes.
                For lngNextShape = 1 To vsoClickedShapes.Count
                    strMessage = strMessage & vsoClickedShapes. _
                        Item(lngNextShape).NameU & vbCrLf
                Next lngNextShape
                
                If (mvsoWindow.Application.AlertResponse = 0) Then
                    MsgBox strMessage
                End If
            Else
                If (mvsoWindow.Application.AlertResponse = 0) Then
                    MsgBox mstrNoShapesFoundPrompt
                End If
            End If
        End If
    End If

    Exit Sub
    
mvsoWindow_MouseUp_Err:
    Debug.Print Err.Description

End Sub


