Attribute VB_Name = "Berechnung"
Option Explicit
' V 1.05 03.01.2011
' Version wird in TM_Plate angezeigt
' Eduktmischung wird in TM_Plate angezeigt
' Umsatz aus alkylat wird nicht 50:50 angenommen (keine division durch 2!)-> U_buten204 wird ausgegeben OK
' Bezeichnungen der Proben werden in die m%/V%/n% kopiert, ohne den Dateipfad
' Mittelwert der einzelnen anteile werden erechnet (MITTELWERT=...)
'

' V.1.04 8.12.2010
' Berechnung der Konzentration der Einzelnen Komponenten
' Berechung von mfrac muss vor der berechnung von nfrac etc durchgefhrt werden, insb. da mfrac ibutan falsch berechnet wurde (peak-berladen)
' ->m%ibutan = 1-Summe aller anderen

' V1.03 3.12.2010
' DoStats wird auskommentiert -> Keine statistc durch die Auswertung (berflssig)
' - Auswahlmenu fr die Eingabe der Eduktmischung.
' Eduktmischungen in der Vorlagedatei, erste Zeile wird intern weiterhin als "Eduktmischung gewertet
'
' V1.02 25.08.2010
' - Umsatzbestimmung ber die Produktpeakts
'   - mpprod_ges / 2 = Produktarea * mpSTD / AreaSTD / 2 = mpbutenaus
'   - Summe (Area * 8-n/n * mpSTD / Areastd
'   - mpButen_ein / mpprod_ges
'   - stCorr war 11 = flascher INdex (P37 in Vorlage.xls)=> 13 index korrigiert
'V=1.01; 1.0 am 29.6.2010 . Stephan Aschauer
' nderungen 1.01 am 9.8.2010
' - 1-Buten wird nicht als Edukt gezhlt
' - isoverload wird nicht mehr ausgewertet
' - Menge des Alkylats bezogen auf die Produktgesammtmasse wird ausgewert in Erg(K,SumProduktNOP)
' - Ethanol/Isopropanol als Lsemittel wird aus der Auswertung entfernt
' Bugfixes - "NOP" = Noprodukt wid erst ausgewertet nachdem die Eduktmenge bestimmt wurde
'


Static Function pToRVP(ByVal p As Double, ByVal T As Double) As Double 'p in bar; pToRVP in bar
p = p * bar2psi  'bar in psi
pToRVP = (10 ^ ((Log(p) - RVPD + RVPC * 5 / (9 * T)) / (RVPA * 5 / (T * 9) - RVPB))) / bar2psi
End Function

Static Function RVPtoP(ByVal p As Double, ByVal T As Double) As Double 'pToRVP in bar; p in bar
Static M As Double, B As Double, X As Double
p = p * bar2psi
M = ((RVPA / (T * 9 / 5)) - RVPB)
B = (-RVPC / (T * 9 / 5)) + RVPD
X = Log10(p)
RVPtoP = Exp(M * X + B) / bar2psi
End Function

Static Function Log10(X)
   Log10 = Log(X) / Log(10#)
End Function



Function getKompAnz()
I = 0
A = "S"
Do While A <> "Area Total"
A = Cells(ROW_Namen, COL_Namen + I)
KompVarian(I) = A
I = I + 1
Loop
AnzKomp = I - 2 '0 ist positiv I+I+1 wird nachher ausgefhrt Area muss weg
getKompAnz = AnzKomp
End Function

Function WriteVar(ByVal Bereich As String, ByVal Var As String, ByVal value As Variant) As Integer
Dim Inifile As String, Exedir As String, Defstring As String * 20, StrLength As Integer
Exedir = ThisWorkbook.Path
If Right$(Exedir, 1) <> "\" Then Exedir = Exedir & "\"
Inifile = Exedir & "SUMRPT.INI"
WriteVar = WritePrivateProfileString32(Bereich, Var, CStr(value), Inifile)
End Function

Function getMessAnz()
Sheets("TM_Plate").Activate
A = "M"
I = 0
Do While A <> ""
A = Cells(ROW_Edukte + I, 1)
I = I + 1
Loop
AnzMess = I
AnzMess = AnzMess - 1 'V1.03 -1 anstatt -2 '0 ist positiv I+I+1 wird nachher ausgefhrt
If AnzMess > 0 Then Err = WriteVar("BERECHNUNG", "AnzMess", AnzMess)
getMessAnz = AnzMess
End Function

Function Init()
ReDim mp_Buten_aus(AnzMess) As Double
ReDim mp_iButan_aus(AnzMess) As Double
ReDim SampleNames(AnzMess) As String
ReDim mp_Buten_aus50(AnzMess) As Double
ReDim mp_Buten_ausVar(AnzMess) As Double
ReDim Temp(AnzMess) As Double
ReDim Time(AnzMess) As Double
ReDim Feed(AnzMess) As Double
ReDim Area_STD(AnzMess) As Long
ReDim mp_STD(AnzMess) As Double
'ReDim Erg(AnzMess, AnzErg) As Double
ReDim Values(AnzMess, AnzKomp) As tyVal
ReDim isOverload(AnzMess) As Boolean
ReDim KompAdresse(AnzKomp) As Integer
'ReDim KompVarian(AnzKomp) As String
ReDim komp(AnzKompMax) As tyKomp
For I = 0 To AnzKompMax
    Set komp(I) = New tyKomp
Next
Set curKomp = New tyKomp
ReDim Names(AnzMess) As String
C5_7 = ""
C8 = ""
DMH = ""
C9 = ""
C10 = ""
Olefine = ""
Parafine = ""
IsoParafine = ""
With OpenDialog
Cmin = Val(.ComboBoxVonC.value)
Cmax = Val(.ComboBoxBisC.value)
SetC = CBool(.CheckBoxC.value)
SetBatch = CBool(.CheckBoxBatch.value)
SetDGL = CBool(.CheckBoxDGL.value)
SetVP = CBool(.CheckBoxVP.value)
SetNP = CBool(.CheckBoxNP.value)
SetErgX = CBool(.CheckBoxErgX.value)
SetCP = CBool(.CheckBoxCP.value)
CalcType = .ComboBasis.value
SetTempAbb = CBool(.CheckBoxTemp.value)
SetChart = CBool(.CheckBoxChart.value)
End With
End Function

Function SetAdress()
Dim TmpName As String
For I = 0 To AnzKomp
    TmpName = KompVarian(I)
    If ((InStr(TmpName, "I-C")) Or (InStr(TmpName, "O-C"))) Then 'Prft nach I-Parafinnen und Olefinen z.b. O-C12
        TmpName = VBA.Strings.Mid(TmpName, 1, 5)
    End If
    KompAdresse(I) = getKompIndexByName(TmpName)
    If (KompAdresse(I) = -1) Then
    MsgBox ("Komponente " & KompVarian(I) & " konnte nicht gefunden werden, bitte in die Vorlage.xls einfgen. Evt Rechtschreibfehler!")
        SetAdress = -1
        Exit Function
    End If
Next
End Function

Function Umsatz()

End Function

Function getCellsFromTemplate()

Self.Activate
Sheets("TM_PLATE").Select
Rows(ROW_Edukte).Insert 'Zeile hinzufgen damit der

For K = 0 To AnzMess
    For I = 0 To AnzKomp
        With Values(K, I)
            .value = Cells(K + ROW_Edukte, I + COL_Namen) * komp(KompAdresse(I)).Corr 'bertrag der Area-Werte um den Korrekturfaktor (Standart = 1) korrigiert
            .Group = komp(KompAdresse(I)).Group
            Erg(K, SumGesamt) = Erg(K, SumGesamt) + .value
            If Not IsProduct(.Group) Then
                Erg(K, SumEdukt) = Erg(K, SumEdukt) + .value
                Else: If ((Cmin > komp(KompAdresse(I)).C) Or (Cmax < komp(KompAdresse(I)).C)) Then .Group = "NOP" 'Definieren der Alkgrenzen C3/C5 und C11/C16
            End If
            If .Group = "NOP" Then Erg(K, SumProduktNOP) = Erg(K, SumProduktNOP) + .value 'Summiert die Nichtbercksichtigen auf
        End With
    Next
    Erg(K, SumProdukt) = Erg(K, SumGesamt) - Erg(K, SumEdukt) - Erg(K, SumProduktNOP) 'Summe Produkt = GEsammtsumme - Edukt(CAT,STD) - Lsemittel(Ethanol,Isopropanol) - Nicht Produkt/NOP
    Names(K) = Cells(K + ROW_Edukte, 2)
Next


End Function

Sub WriteInfoAndSetNames()
Self.Activate
Sheets("TM_PLATE").Select
Cells(1, 1) = "Version"
Cells(1, 2) = Version
Cells(2, 1) = "nderungsdatum"
Cells(2, 2) = VerDatum
Cells(3, 1) = "Auswertungsdatum"
Cells(3, 2) = Now
Cells(5, 4) = "Time"
Sheets("m%").Select
Cells(2, 1) = "Isobutane"
Cells(3, 1) = "2-Buten"
Cells(4, 1) = "STD"
Cells(1, 2) = "wt-%"
Cells(1, 3) = "mol-%"
Cells(1, 4) = "c in mol/l"

Cells(2, 2) = mp_iButan_ein
Cells(3, 2) = mp_Buten_ein
Cells(4, 2) = mp_STD_ein
Cells(2, 3) = np_iButan_ein
Cells(3, 3) = np_Buten_ein
Cells(4, 3) = np_STD_ein
Cells(2, 4) = c_iButan_ein
Cells(3, 4) = c_2Buten_ein

Cells(2, 2).Name = "mp_iButan_ein"
Cells(3, 2).Name = "mp_2Buten_ein"
Cells(4, 2).Name = "mp_STD_ein"
Cells(2, 3).Name = "np_iButan_ein"
Cells(3, 3).Name = "np_2Buten_ein"
Cells(4, 3).Name = "np_STD_ein"
Cells(2, 4).Name = "c_iButan_ein"
Cells(3, 4).Name = "c_2Buten_ein"
For K = 1 To AnzMess
Sheets("TM_PLATE").Select
Cells(K + ROW_Edukte, STD.Adr + COL_Namen).Name = "Area_STD_" & K
'Cells(K + ROW_Edukte, STD.Adr).Select
'ActiveWorkbook.Names.Add Name:="Area_STD_" & K, RefersTo:=Cells(K + ROW_Edukte, STD.Adr)
Next
End Sub

Sub Konzentration()
Dim hilf As Double
Self.Activate
Vorlage.Activate
Vorlage.Sheets("C").Copy After:=Self.Sheets("TM_PLATE")
Sheets("C").Activate

Cells(2, 2) = c_iButan_0
Cells(2, 3) = c_Buten_0
For K = 1 To AnzMess
 Cells(2 + K, 2) = Values(K, iButan.Adr).Gesamt.ci
 Cells(2 + K, 3) = Values(K, cButen2.Adr).Gesamt.ci
 Cells(2 + K, 4) = getConcentration(K, C3)
 Cells(2 + K, 5) = getConcentration(K, C4)
 Cells(2 + K, 6) = getConcentration(K, C5)
 Cells(2 + K, 7) = getConcentration(K, C6)
 Cells(2 + K, 8) = getConcentration(K, C7)
 Cells(2 + K, 9) = getConcentration(K, C8)
 Cells(2 + K, 10) = Values(K, TMP224.Adr).Gesamt.ci + Values(K, TMP223.Adr).Gesamt.ci + Values(K, TMP234.Adr).Gesamt.ci + Values(K, TMP233.Adr).Gesamt.ci
 Cells(2 + K, 11) = getConcentration(K, DMH)
 Cells(2 + K, 12) = getConcentration(K, C9)
 Cells(2 + K, 13) = getConcentration(K, C10)
 Next
End Sub

Sub getK()
Dim helper As String
Sheets("C").Activate
For K = 1 To 12
helper = "=ln(c_2Buten_0/R[0]C[-12])"
    Cells(2 + K, 15).FormulaR1C1 = helper
Next
Cells(2 + 12, 3).FormulaR1C1 = "SLOPE(Cells(3,15):Cells(13,15),Cells(3,1):Cells(13,1))"
End Sub

Function WriteToTemplate()
Dim hilf() As String
Dim L As Integer

Call Konzentration
Call WriteInfoAndSetNames

Texter(1) = "Massenanteil in der Probe in %"
Texter(2) = "Stoffmengenanteil in der Probe in %"
Texter(3) = "Volumenanteil in der Probe in %"
Texter(4) = "Massenanteil der Produkte in %"
Texter(5) = "Stoffmengenanteil der Produkte in %"
Texter(6) = "Volumenanteil der Produkte in %"
Texter(7) = "Einzelkonzentration in mol/l"
Self.Activate
Sheets("TM_PLATE").Select

'For K = 1 To AnzMess
'    Hilf = Split(Cells(ROW_Edukte + K, 2), "\", -1, vbTextCompare)
'    SampleNames(K) = Hilf(UBound(Hilf))
'    For L = 1 To 7
'        Cells(ROW_Edukte + L * (AnzMess + 3) + K, 1) = Hilf(UBound(Hilf))
'    Next
'    For I = 0 To AnzKomp
'        With Values(K, I).Gesamt
'            Cells(ROW_Edukte - 2, I + COL_Namen) = komp(KompAdresse(I)).RON 'Schreibt die RON ber die Verbindungen in der Varian-Ausgabe (TM_PLATE)
'            Cells(ROW_Edukte + 2 + 1 * AnzMess + K + 1, I + COL_Namen) = .mfrac
'            Cells(ROW_Edukte + 4 + 2 * AnzMess + K + 2, I + COL_Namen) = .nfrac
'            Cells(ROW_Edukte + 6 + 3 * AnzMess + K + 3, I + COL_Namen) = .Vfrac
'            Cells(ROW_Edukte + 14 + 7 * AnzMess + K + 7, I + COL_Namen) = .ci
'        End With
'        With Values(K, I).Produkt
'            Cells(ROW_Edukte + 8 + 4 * AnzMess + K + 4, I + COL_Namen) = .mfrac
'            Cells(ROW_Edukte + 10 + 5 * AnzMess + K + 5, I + COL_Namen) = .nfrac
'            Cells(ROW_Edukte + 12 + 6 * AnzMess + K + 6, I + COL_Namen) = .Vfrac
'        End With
'    Next
'Next
'For L = 1 To 7
'Cells(ROW_Edukte + L * (AnzMess + 3), 1) = Texter(L)
'Cells(ROW_Edukte + L * (AnzMess + 3) + AnzMess + 1, 1) = "Mittelwert"
'    For I = 0 To AnzKomp
'        Cells(ROW_Edukte + L * (AnzMess + 3) + AnzMess + 1, COL_Namen + I).Select
'        ActiveCell.FormulaR1C1 = "=AVERAGE(R[-" & AnzMess & "]C:R[-1]C)"
'    Next
'Next
End Function

Function SetStandart()
Dim EduktIndex As Byte
Vorlage.Sheets("Edukt").Activate
EduktIndex = OpenDialog.ComboEdukt.ListIndex
mges_ein = 1 ' Erg(0, SumEdukt)
mp_cButen2_ein = 0 'Values(0, cButen2.Adr).Value / mges_ein
mp_tButen2_ein = 0 ' Values(0, tButen2.Adr).Value / mges_ein
mp_Buten1_ein = 0 'Values(0, Buten1.Adr).Value / mges_ein
mp_CAT_ein = 0 'Values(0, Cat.Adr).Value / mges_ein

mp_STD_ein = Cells(3 + EduktIndex, 6) 'Values(0, STD.Adr).Value / mges_ein

mp_iButan_ein = Cells(3 + EduktIndex, 4) 'Values(0, iButan.Adr).Value / mges_ein 'iButan-Edukt-eingangsmassen%
mp_Buten_ein = Cells(3 + EduktIndex, 5) 'mp_cButen2_ein + mp_tButen2_ein '+ mp_Buten1_ein 'Buten-Edukt-eingangsmassen%
PO_ein = mp_iButan_ein / mp_Buten_ein
For K = 0 To AnzMess
    Area_STD(K) = Values(K, STD.Adr).value
Next

hilf = mp_iButan_ein / iButan.Molar + mp_Buten_ein / cButen2.Molar + mp_STD_ein / STD.Molar
np_Buten_ein = mp_Buten_ein / cButen2.Molar / hilf
np_iButan_ein = mp_iButan_ein / iButan.Molar / hilf
np_STD_ein = mp_STD_ein / STD.Molar / hilf
rho_ein = mp_Buten_ein * cButen2.rhoT(Temp(0)) + mp_iButan_ein * iButan.rhoT(Temp(0)) + mp_STD_ein * STD.rhoT(Temp(0))
Molar_ein = np_Buten_ein * cButen2.Molar + np_iButan_ein * iButan.Molar + np_STD_ein * STD.Molar
c_ges = rho_ein / Molar_ein
c_2Buten_ein = c_ges * np_Buten_ein
c_iButan_ein = c_ges * np_iButan_ein

End Function

Function CreateSelektivityLists(ByVal ActIdx As Integer)
If ((curKomp.Group <> "STD") And (curKomp.Group <> "CAT") And (curKomp.Group <> "E")) Then '((Not InStr(CurKomp.Name, "I-C")) And (Not InStr(CurKomp.Name, "O-C")) And'Prfen C4, Interner STD und Cat
    Select Case curKomp.C
        Case 3: C3 = C3 & ";" & ActIdx
        Case 4: C4 = C4 & ";" & ActIdx
        Case 5: C5 = C5 & ";" & ActIdx
        Case 6: C6 = C6 & ";" & ActIdx
        Case 7: C7 = C7 & ";" & ActIdx
        Case 3 To 7: C5_7 = C5_7 & ";" & ActIdx 'C3 bis C7
        Case 8
            Select Case curKomp.Group
                Case "D": DMH = DMH & ";" & ActIdx ' Erkennen aller DMHs
                Case "M", "O": C8 = C8 & ";" & ActIdx 'Erkennen aller M-Heptane und C8Olefine
            End Select
        Case 9: C9 = C9 & ";" & ActIdx 'alle C9
        Case 10 To 16: C10 = C10 & ";" & ActIdx ' Alle C10+
    End Select
        
    Select Case curKomp.Group ' Auftrennung in Olefine, Parafine, Isoparafine
        Case "O": Olefine = Olefine & ";" & ActIdx
        Case "D", "M", "T", "I": IsoParafine = IsoParafine & ";" & ActIdx
        Case "P": Parafine = Parafine & ";" & ActIdx
    End Select
End If
End Function

Function CreateFracRonPi()
For K = 1 To AnzMess
    For I = 0 To AnzKomp
        If Area_STD(K) <> 0 Then
            Area_Komp = Values(K, I).value
            Values(K, I).Gesamt.mfrac = Area_Komp / Area_STD(K) * mp_STD_ein 'm%Komp = A_Komp / A_STD * m%STD
            Erg(K, mSum) = Erg(K, mSum) + Values(K, I).Gesamt.mfrac
        Else: MsgBox ("STD-Flche bei Messung " & K & " ist 0 -> Division durch Null, Abbruch")
            Exit Function
        End If
    Next
Values(K, iButan.Adr).Gesamt.mfrac = 1 - (Erg(K, mSum) - Values(K, iButan.Adr).Gesamt.mfrac) ' Da Isbutan berladen m% = 1-Summe aller anderen
Next
For I = 0 To AnzKomp
    Set curKomp = komp(KompAdresse(I))
    Err = CreateSelektivityLists(I)
    For K = 1 To AnzMess 'K<>0 da 0 die die Zeile der Messung der Eduktzusammensetzung ist
            Area_Komp = Values(K, I).value
            With Values(K, I).Gesamt
                .nfrac = .mfrac / curKomp.Molar
                .Vfrac = .mfrac / curKomp.rho
                .Pi = curKomp.Pi * .nfrac '
                .RON = .mfrac * curKomp.RON
                Erg(K, nSum) = Erg(K, nSum) + .nfrac
                Erg(K, VSum) = Erg(K, VSum) + .Vfrac
                Erg(K, PSum) = Erg(K, PSum) + .Pi
                Erg(K, RONP) = Erg(K, RONP) + .RON
                If IsProduct(Values(K, I).Group) Or Values(K, I).Group = "NOP" Then
                    mp_Buten_aus50(K) = mp_Buten_aus50(K) + .mfrac / 2
                    If curKomp.C > 4 Then
                        mp_Buten_ausVar(K) = mp_Buten_ausVar(K) + .mfrac * ((curKomp.C - 4) / curKomp.C)
                    Else: mp_Buten_ausVar(K) = mp_Buten_ausVar(K) + .mfrac
                    End If
                End If
            End With
            With Values(K, I).Produkt
                If IsProduct(Values(K, I).Group) Then
                    If (Erg(K, SumProdukt) <> 0) Then
                        'Aufsummierung der RON Werte ohne ibutan, 2buten, cat und std
                        .mfrac = Area_Komp / Erg(K, SumProdukt)
                        .nfrac = .mfrac / curKomp.Molar
                        .Vfrac = .mfrac * curKomp.rho
                        
                        .RON = .mfrac * curKomp.RON
                        .Pi = curKomp.Pi 'bertragung des Sattdampfdruckes auf die Zelle
'                        kontrolle(K) = kontrolle(K) + .mfrac
                        Erg(K, RON) = Erg(K, RON) + .RON
                        Erg(K, nSumP) = Erg(K, nSumP) + .nfrac
                        Erg(K, VSumP) = Erg(K, VSumP) + .Vfrac
                        'Erg(K, PSumP) = Erg(K, PSumP) + .Pi
                    End If
                End If
            End With
    Next
Next
For K = 1 To AnzMess
    For I = 0 To AnzKomp
        With Values(K, I).Gesamt
            .nfrac = .nfrac / Erg(K, nSum)
            .Vfrac = .Vfrac / Erg(K, VSum)
            .ci = Erg(K, nSum) * .nfrac / Erg(K, VSum) * 1000 'Konzentration (Summe Stoffmengenbrche * molarer anteil / Summe Volumenanteil in [mol/l]
        End With
        With Values(K, I).Produkt
            .nfrac = .nfrac / Erg(K, nSumP) ' Tatslicher Stoffmengenanteil berechnen
            .Vfrac = .Vfrac / Erg(K, VSumP) ' Tatslicher Volumenanteil berechnen
            .Pi = .nfrac * .Pi
            Erg(K, PSumP) = Erg(K, PSumP) + .Pi ' Aufsummieren von Pi zu Pges
        End With
    Next
Next
End Function

Sub BerOpen()
Dim StrIngo As String
Dim Anzahl As Byte
Dim p As Byte
Application.Calculation = xlCalculationManual
'If Not isSheet("TM_PLATE") Then: MsgBox ("Kein TM_PLATE zum Auswerten, bitte erst PROCESS ausfhren"): Exit Sub
Set TWorkbook = ThisWorkbook
Call SetSelfAdress
Call ReadFromIni
If Not ActivateWorkbook(DateiVorlage) Then
    Set Vorlage = Workbooks.Open(StoffPath & DateiVorlage) 'Vorlage ffnen
Else: Set Vorlage = Workbooks(DateiVorlage)
End If
Vorlage.Sheets("Edukt").Activate
Anzahl = Cells(1, 2)
For p = 3 To Anzahl + 2
    StrIngo = Round(Cells(p, 8), 0) & ":1=" & Cells(p, 3) & " " & Cells(p, 1)
    OpenDialog.ComboEdukt.AddItem (StrIngo)
Next
OpenDialog.Show
End Sub

Sub SortOpen()
SortDialog.Show
End Sub

Sub SortTmPlate()
Dim SortType As String
Dim SortMess As Integer
Dim Adresse As Integer
Dim Texter() As String

SortType = SortDialog.ComboSortType.value
SortMess = SortDialog.ComboSortMess.value
Sheets(SortType).Activate
Adresse = SortMess + 2
Columns("F:GW").Select
Debug.Print Adresse
Call Selection.Sort(Key1:=Range("F" & Adresse), Order1:=xlDescending, Header:=xlGuess, OrderCustom:=1, MatchCase:=False, Orientation:=xlLeftToRight, DataOption1:=xlSortNormal)
End Sub

Function ReadVar(ByVal Bereich As String, ByVal Var As String) As String
Dim Inifile As String, Exedir As String, Defstring As String * 20, StrLength As Integer
Exedir = ThisWorkbook.Path
If Right$(Exedir, 1) <> "\" Then Exedir = Exedir & "\"
Inifile = Exedir & "Alkylierung.INI"
StrLength = GetPrivateProfileString32(Bereich, Var, "", Defstring, 259, Inifile)
ReadVar = Left$(Defstring, StrLength)
End Function

Sub ReadFromIni()
'DataWB = ReadVar("SUMRPT", "LastFile")
AnzKompMax = ReadVar("BERECHNUNG", "AnzKompMax")
ReDim KompVarian(2 * AnzKompMax) As String
DateiVorlage = ReadVar("BERECHNUNG", "Stoffdaten")
StoffPath = ReadVar("BERECHNUNG", "StoffdatenPath")
Version = ReadVar("BERECHNUNG", "Version")
VerDatum = ReadVar("BERECHNUNG", "Datum")
RonCmax = ReadVar("BERECHNUNG", "RONCmax")
RonCmin = ReadVar("BERECHNUNG", "RONCmin")
TempCol = GetIndexOfExcelCol(ReadVar("BERECHNUNG", "TempCol")) + 1
Temp0Row = ReadVar("BERECHNUNG", "Temp0Row")
TimeCol = GetIndexOfExcelCol(ReadVar("BERECHNUNG", "TimeCol")) + 1
CaptionRow = ReadVar("BERECHNUNG", "CaptionRow")
ValueRow = ReadVar("BERECHNUNG", "ValueRow")
FeedCol = GetIndexOfExcelCol(ReadVar("BERECHNUNG", "FeedCol")) + 1
'Standarteinstellung falls 0
If RonCmax <= 9 Or RonCmax >= 17 Then RonCmax = 11
If RonCmin <= 0 Or RonCmin >= 6 Then RonCmin = 5
If TempCol = 0 Then TempCol = 5
If Temp0Row = 0 Then Temp0Row = 4
End Sub

Function SetSelfAdress()
Set Self = ActiveWorkbook
Set WBSelf = ActiveWorkbook
End Function

Sub ActivateOrOpen(ByVal WBidx As Byte)
With OpenDialog
If Not ActivateWorkbook(.ListFiles.List(0)) Then
    Workbooks.Open (.LabelVerz & "\" & .ListFiles.List(0))
End If
Set Self = Workbooks(.ListFiles.List(0))
End With
End Sub

Sub Auswertung()

Dim kontrolle() As Double
Dim files As Byte
Dim p As Byte
Dim isDev As Boolean
isDev = True
TWorkbook.Activate


For p = 1 To OpenDialog.ListFiles.ListCount
ActivateOrOpen (p)
Self.Activate
Sheets("TM_PLATE").Select
Cells(1, 1).Select

AnzKomp = getKompAnz() 'Ermittlen der Komponentenanzahl in der TM_PLATE

AnzMess = getMessAnz() 'Ermittlen der Messungsanzahl in der TM_PLATE

Err = Init() 'Initialisieren der Variablen anhand der Messungsanzahl und Komponentenanzahl

AnzKompVorlage = DefKomp() 'Ermitteln und defenieren der Komponten aus der Vorlage

Err = SetAdress() 'Adress Array der TM_PLATE Verbindungen zu den Komponenten aus der Vorlage
If (Err = -1) Then Exit Sub

If (Not isDev) Then
Err = getCellsFromTemplate() 'Kopiert die Zellen aus dem Template in "Values"

Err = SetStandart() 'Errechnet den Standart-Peak vom Cyclohexan in m%

'If isOverload(0) Then MsgBox ("Der Isbutan-Edukt-Peak ist berladen, Abbruch"): Exit Sub

Err = CreateFracRonPi() 'Errechenen der Massenbrche, Molenbrche, RONs und Partialdrcke

Err = CalcConvSelec() 'Berechnet die Umstze sowie die Selektivitten

Err = TmpSheetWrite() 'Ausgabe aller zwischenrechnugen

Err = WriteToSheet() 'Schreiben der Erg() in die Zellen der Tabelle "Erg"

Err = WriteToTemplate() ' Ron, Massen, stoffmengen und Volumenbrche in die Template V1.03

If CreateGraph Then
    'PrintGraphSel (AnzMess)
    'PrintGraphConv (AnzMess)
End If
Else
    Dev2011
End If
Self.Save
Self.Close
OpenDialog.ListFiles.RemoveItem 0
Next

Application.DisplayAlerts = True
OpenDialog.Hide

Application.MenuBars(xlWorksheet).Menus("Auswertung").MenuItems("Sortieren").Enabled = True ' v1.05
Application.Calculation = xlCalculationAutomatic
End Sub


Function TmpSheetWrite()
Self.Activate
Dim wsNew As Worksheet
If Not isSheet("tmp") Then
    Set wsNew = Worksheets.Add
    With wsNew
        .Name = "tmp"
        .Move After:=Sheets("TM_PLATE")
    End With
    Set wsNew = Nothing
End If
Sheets("tmp").Activate
Cells(1, nSum + 1) = "Summe der m%i/Mi [mol/g] = Stoffmengendichte Alklat"
Cells(1, VSum + 1) = "Summe der m%i*rho_i [g/ml] = Massendichte Alkylat"
For K = 1 To AnzMess
    For I = 0 To AnzErg 'Ersten drei und letzten 2 Erg nicht relevant fr die Ausgabe
    Cells(K + 2, I + 1) = Erg(K, I)
    Next
Next
End Function


Function WriteToSheet()

Self.Activate
If Not isSheet("ErgX") Then
Vorlage.Activate
    If isSheet("ErgX") Then
        Vorlage.Sheets("ErgX").Copy After:=Self.Sheets("TM_PLATE")
        Else: MsgBox ("In der Datei Vorlage.xls konnte die Tabelle 'ErgX' nicht gefunden werden. Abbruch"): Exit Function
    End If
End If

Self.Activate
Sheets("ErgX").Activate
For K = 1 To AnzMess
    For I = 1 To AnzPrint - 2
        Cells(K + 2, I + 2) = Erg(K, I + 2)
    Next
    Cells(K + 2, 1) = Names(K) 'GCName aus dem Template
    Cells(K + 2, 2) = K 'Zeilenummer
Next

If Not isSheet("ErgY") Then
Vorlage.Activate
    If isSheet("ErgY") Then
        Vorlage.Sheets("ErgY").Copy After:=Self.Sheets("TM_PLATE")
        Else: MsgBox ("In der Datei Vorlage.xls konnte die Tabelle 'ErgY' nicht gefunden werden. Abbruch"): Exit Function
    End If
End If

Self.Activate
Sheets("ErgY").Activate
For K = 1 To AnzMess
    For I = 1 To AnzPrint - 2
        Cells(I + 2, K + 2) = Erg(K, I + 2)
    Next
    Cells(1, K + 2) = Names(K) 'GCName aus dem Template
    Cells(2, K + 2) = K 'Zeilenummer
Next

Err = FormatErgCellsX()
Err = FormatErgCellsY()

End Function

Function FormatErgCellsY()
Dim tp As String
Self.Activate
Sheets("ErgY").Activate
    Range("B15").Select 'Formatieren auf CX-CXX
    ActiveCell.FormulaR1C1 = "C" & Cmin & "-C" & Cmax
    With ActiveCell.Characters(Start:=2, Length:=1).Font
        .Subscript = True
    End With
    With ActiveCell.Characters(Start:=5, Length:=2).Font
        .Subscript = True
    End With
    
    Range("B16").Select 'Formatieren auf CX-CXX
    ActiveCell.FormulaR1C1 = "C" & Cmin & "-C" & Cmax
    With ActiveCell.Characters(Start:=2, Length:=1).Font
        .Subscript = True
    End With
    With ActiveCell.Characters(Start:=5, Length:=2).Font
        .Subscript = True
    End With
    
    Range("B5").Select 'Formatieren auf CX-C7
    ActiveCell.FormulaR1C1 = "C" & Cmin & "-C7"
    With ActiveCell.Characters(Start:=2, Length:=1).Font
        .Subscript = True
    End With
    With ActiveCell.Characters(Start:=5, Length:=1).Font
        .Subscript = True
    End With
    
    Select Case CalcType
        Case "Masse": tp = "m"
        Case "Stoffmenge": tp = "n"
        Case "Volumen": tp = "V"
    End Select
    Range("A5").value = Range("A5").value & tp & "%"
End Function

Function FormatErgCellsX()
Self.Activate
Sheets("ErgX").Activate
    Range("U2").Select 'Formatieren auf CX-CXX
    ActiveCell.FormulaR1C1 = "C" & Cmin & "-C" & Cmax
    With ActiveCell.Characters(Start:=2, Length:=1).Font
        .Subscript = True
    End With
    With ActiveCell.Characters(Start:=5, Length:=2).Font
        .Subscript = True
    End With
    
    Range("S2").Select 'Formatieren auf CX-CXX
    ActiveCell.FormulaR1C1 = "C" & Cmin & "-C" & Cmax
    With ActiveCell.Characters(Start:=2, Length:=1).Font
        .Subscript = True
    End With
    With ActiveCell.Characters(Start:=5, Length:=2).Font
        .Subscript = True
    End With
    
    Range("G2").Select 'Formatieren auf CX-C7
    ActiveCell.FormulaR1C1 = "C" & Cmin & "-C7"
    With ActiveCell.Characters(Start:=2, Length:=1).Font
        .Subscript = True
    End With
    With ActiveCell.Characters(Start:=5, Length:=1).Font
        .Subscript = True
    End With
    
    Select Case CalcType
        Case "Masse": tp = "m"
        Case "Stoffmenge": tp = "n"
        Case "Volumen": tp = "V"
    End Select
    Range("E1").value = Range("E1").value & tp & "%"
    Range("Q1").value = Range("Q1").value & tp & "%"
    Range("R1").value = Range("R1").value & tp & "%"
    Range("S1").value = Range("S1").value & tp & "%"
End Function

Function CalcConvSelec()
For K = 1 To AnzMess
    'mp_Buten_aus50(K) =
    mp_Buten_aus(K) = Values(K, cButen2.Adr).Gesamt.mfrac + Values(K, tButen2.Adr).Gesamt.mfrac '+ Values(K, Buten1.Adr).Gesamt.mfrac
    Erg(K, U_Buten) = (1 - mp_Buten_aus(K) / mp_Buten_ein) * 100 'Buten Umsatz
    Erg(K, U_Buten_50) = mp_Buten_aus50(K) / mp_Buten_ein * 100
    Erg(K, U_Buten_Var) = mp_Buten_ausVar(K) / mp_Buten_ein * 100
    Erg(K, U_Buten_204) = (Erg(K, SumProdukt) + Erg(K, SumProduktNOP)) / Area_STD(K) * mp_STD_ein / mp_Buten_ein * 100
    If Not AllOverload Then
        mp_iButan_aus(K) = Values(K, iButan.Adr).Gesamt.mfrac
        Erg(K, U_iButan) = (1 - mp_iButan_aus(K) / mp_iButan_ein) * 100 'iButan Umsatz
    End If
    Select Case CalcType
        Case "Masse"
        Erg(K, S_224TMP) = Values(K, TMP224.Adr).Produkt.mfrac * 100
        Erg(K, S_223TMP) = Values(K, TMP223.Adr).Produkt.mfrac * 100
        Erg(K, S_234TMP) = Values(K, TMP234.Adr).Produkt.mfrac * 100
        Erg(K, S_233TMP) = Values(K, TMP233.Adr).Produkt.mfrac * 100
        Case "Stoffmenge"
        Erg(K, S_224TMP) = Values(K, TMP224.Adr).Produkt.nfrac * 100
        Erg(K, S_223TMP) = Values(K, TMP223.Adr).Produkt.nfrac * 100
        Erg(K, S_234TMP) = Values(K, TMP234.Adr).Produkt.nfrac * 100
        Erg(K, S_233TMP) = Values(K, TMP233.Adr).Produkt.nfrac * 100
        Case "Volumen"
        Erg(K, S_224TMP) = Values(K, TMP224.Adr).Produkt.Vfrac * 100
        Erg(K, S_223TMP) = Values(K, TMP223.Adr).Produkt.Vfrac * 100
        Erg(K, S_234TMP) = Values(K, TMP234.Adr).Produkt.Vfrac * 100
        Erg(K, S_233TMP) = Values(K, TMP233.Adr).Produkt.Vfrac * 100
    End Select
    Erg(K, S_TMP) = Erg(K, S_224TMP) + Erg(K, S_223TMP) + Erg(K, S_234TMP) + Erg(K, S_233TMP)
    Erg(K, S_DMH) = getSelectivity(K, DMH) * 100
    Erg(K, S_C5_7) = getSelectivity(K, C5_7) * 100
    Erg(K, S_C8) = getSelectivity(K, C8) * 100
    Erg(K, S_C9) = getSelectivity(K, C9) * 100
    Erg(K, S_C10) = getSelectivity(K, C10) * 100
    Erg(K, PSumP) = pToRVP(Erg(K, PSumP), T_RVP)
    Erg(K, SUM_O) = getSelectivity(K, Olefine) * 100
    Erg(K, SUM_P) = getSelectivity(K, Parafine) * 100
    Erg(K, SUM_I) = getSelectivity(K, IsoParafine) * 100
    Erg(K, A_Alkylat) = Round(Erg(K, SumProdukt) / (Erg(K, SumProdukt) + Erg(K, SumProduktNOP)) * 100, 0)
Next
End Function

Function getSelectivity(ByRef Idx As Integer, ByRef List As String) As Double
Dim Hilfe() As String
Dim T2 As Double
Dim T1 As Integer
Dim Lange As Integer
Hilfe = Split(List, ";")
For T1 = 1 To UBound(Hilfe)
    Select Case CalcType
        Case "Masse":    T2 = T2 + Values(Idx, CInt(Hilfe(T1))).Produkt.mfrac
        Case "Stoffmenge": T2 = T2 + Values(Idx, CInt(Hilfe(T1))).Produkt.nfrac
        Case "Volumen": T2 = T2 + Values(Idx, CInt(Hilfe(T1))).Produkt.Vfrac
    End Select
Next
getSelectivity = T2
End Function

Function getConcentration(ByRef Idx As Integer, ByRef List As String) As Double
Dim Hilfe() As String
Dim T2 As Double
Dim T1 As Integer
Dim Lange As Integer
Hilfe = Split(List, ";")
For T1 = 1 To UBound(Hilfe)
     T2 = T2 + Values(Idx, CInt(Hilfe(T1))).Gesamt.ci
Next
getConcentration = T2
End Function

Function IsProduct(ByVal grp As String) As Boolean 'Prft ob die Verbindung ein Produkt oder Edukt/Std/Cat/Lsemittel ist
If (grp = "E") Or _
    (grp = "CAT") Or _
    (grp = "STD") Or _
    (grp = "NOP") Or _
    (grp = "LM") _
    Then IsProduct = False Else: IsProduct = True
End Function



Function DefKomp() As Long

Const stName = 1 'Positionen in der Vorlage.Stoffwerte-Datei
Const stRON = 2
Const stC = 3
Const stH = 4
Const stBP = 5
Const strho = 6
Const stGroup = 7
Const stSattA = 8
Const stSattB = 9
Const stSattC = 10
Const stCorr = 13
Const stMName = 14 'Excell und Modell-Bezeichnungen der Spezies

Dim Cell As Variant
Dim N As Integer
Dim T1 As Integer

Set iButan = New tyKomp
Set cButen2 = New tyKomp
Set tButen2 = New tyKomp
Set Buten1 = New tyKomp
Set STD = New tyKomp
Set Cat = New tyKomp
Set TMP224 = New tyKomp
Set TMP234 = New tyKomp
Set TMP223 = New tyKomp
Set TMP233 = New tyKomp
Set Ethanol = New tyKomp
Set Isopropanol = New tyKomp
Dim tx(0 To 3) As Double
Dim atx(0 To 3) As Double
Dim cpx(0 To 3) As Double
Dim X As Byte
N = 2

Cell = "S"

Vorlage.Activate
Do While Cell <> ""
        For X = 0 To 3
            tx(X) = Sheets("Dichte").Cells(N, 5 - X)
            cpx(X) = Sheets("cp").Cells(N, 5 - X)
            atx(X) = Sheets("antoine").Cells(N, 5 - X)
        Next
       
        Vorlage.Sheets("Stoffwerte").Activate
        Cell = Cells(N, stName)
        hilf = komp(N - 2).Init(Cells(N, stName), Cells(N, stRON), Cells(N, stC), Cells(N, stH), Cells(N, stBP), Cells(N, strho), Cells(N, stGroup), Cells(N, stCorr), Cells(N, stMName), tx, atx, cpx)
        komp(N - 2).Pi = komp(N - 2).Sattdampf(T_RVP)
        Select Case (Cells(N, stName))
            Case "Cyclohexan": idx_STD = N - 2: Set STD = komp(N - 2)
            Case "Iso-Butan": idx_iButan = N - 2: Set iButan = komp(N - 2)
            Case "1-Butene/Iso-Buten": idx_iButen = N - 2: Set Buten1 = komp(N - 2)
            Case "n-Butan": idx_nButan = N - 2
            Case "Trans-2-Buten": idx_tButen2 = N - 2: Set tButen2 = komp(N - 2)
            Case "Cis-2-buten": idx_cButen2 = N - 2: Set cButen2 = komp(N - 2)
            Case "2-Brom,2-M-Propan": idx_Cat = N - 2: Set Cat = komp(N - 2)
            Case "2,2,4-TMP": idx_224TMP = N - 2: Set TMP224 = komp(N - 2)
            Case "2,3,4-TMP": idx_234TMP = N - 2: Set TMP234 = komp(N - 2)
            Case "2,3,3-TMP": idx_233TMP = N - 2: Set TMP233 = komp(N - 2)
            Case "2,2,3-TMP": idx_223TMP = N - 2: Set TMP223 = komp(N - 2)
            Case "Isopropanol": Set Isopropanol = komp(N - 2)
            Case "Ethanol": Set Ethanol = komp(N - 2)
        End Select
        If (T1 = -1) Then
            ErrorCount = ErrorCount + 1
            MissKomp = MissKomp & ";" & Cells(N, stName)
        End If
        'Debug.Print komp(N - 2).RhoT(273)
    N = N + 1
Loop
DefKomp = N - 1 - 2
End Function

Function getKompIndex(ByRef Elem As Integer) As Long
      '"Normale" Werte vergleichen:
    For getKompIndex = LBound(komp) To UBound(komp)
      If Not IsObject(komp(getKompIndex).Adr) _
      Then If Elem = komp(getKompIndex).Adr _
           Then Exit Function
    Next getKompIndex

  'Kein Treffer:
  getKompIndex = -1
End Function

Function ArrayIndex(ByRef Elem As String) As Long
      '"Normale" Werte vergleichen:
    For ArrayIndex = LBound(KompVarian) To UBound(KompVarian)
      If Not IsObject(KompVarian(ArrayIndex)) _
      Then If Elem = KompVarian(ArrayIndex) _
           Then Exit Function
    Next ArrayIndex

  'Kein Treffer:
  ArrayIndex = LBound(KompVarian) - 1
End Function

Function getKompIndexByName(ByRef Elem As String) As Long
      '"Normale" Werte vergleichen:
    For getKompIndexByName = LBound(komp) To UBound(komp)
      If Not IsObject(komp(getKompIndexByName).Name) _
      Then If Elem = komp(getKompIndexByName).Name _
           Then Exit Function
    Next getKompIndexByName

  'Kein Treffer:
  getKompIndexByName = -1
End Function
