function pdeIL
%PDE die den Stofftransport bei gleichzeitiger Reaktion in der IL darstellt.
m = 0;
global Dab; global Cein; global Knernst;global k; global alpha; global ymax;
Dab = 7.8e-7; %Diffusionsgeschwindigkeit in cm^2/s von 1-Hexen in [C4mim][AlCl4] (Wilke-Chang-Gl.)
Knerst = 28.57142857; %Nernstscher Verteilungskoeffizient zwischen organischer und IL-Phase
Cein = 0.545572934/Knernst; %1-hexen konzentration an der Grenzschicht in mol/L 
alpha = 68.61395435; % Phasenaustauschflche zu organischem Volumen in 1/m
k = 6.53E-06*alpha; %Reaktionsgeschwindigkeitskonstante in 1/s
ymax = 0.29; %maximale IL-Hohe bei 1ml in cm
x = linspace(0,ymax,100);
t = linspace(0,100000,10000);
%t = [3600 9000 14400 18000 79200];


sol = pdepe(m,@pdeILpde,@pdeILic,@pdeILbc,x,t);
u = sol(:,:,1);

figure;
plot(x,u(6,:),x,u(30,:),x,u(60,:),x,u(180,:),x,u(360,:),u(720,:), u(1440,:));

xls = [u(6,:); u(30,:); u(60,:); u(180,:); u(360,:); u(720,:); u(1440,:);];

xlswrite('ausgabe2.xlsx',xls');

% --------------------------------------------------------------------------

function [c,f,s] = pdeILpde(x,t,u,DuDx)
global Cein; global k; global Dab 
c = 1;
f = Dab*DuDx ;
s = -k*u;

% --------------------------------------------------------------------------

function u0 = pdeILic(x)
global Cein
u0 = 0;    
% --------------------------------------------------------------------------

function [pl,ql,pr,qr] = pdeILbc(xl,ul,xr,ur,t)
global k;global Cein
pr = 0;
qr = 1;
pl = ul - Cein*exp(-t*k);
ql = 0;


